#include <proc.h>
#include <sched.h>
#include <mittos/graphics.h>

extern gfx_context *term_fb;
extern gfx_context kernel_fb;

void thread1()
{
    int a = 1;
    gfx_context *ctx = framebuffer_make_subcontext(&kernel_fb, 700, 300, 100, 100);
    while(1) {
        putCharacter(term_fb, 0, 0, RGB(255,255,0), RGB(0,0,0), '0'+(a++%10));
        flip(term_fb);
        draw_line(ctx, 0, 100, 50, ((a-1)%100), RGB(0,0,0));
        draw_line(ctx, 0, 100, 50, (a%100), RGB(255,0,0));
        flip(ctx);

        sched_yield();
    }
}

void thread2()
{
    int a = 0;
    while(1) {
        putCharacter(term_fb, 10, 10, RGB(0,255,255), RGB(0,0,0), 'A'+(a++%10));
        draw_rect(term_fb, 10, 10, 200, 300, RGB((uint8_t)(a%256), 0, 255-(uint8_t)(a%256)));
        flip(term_fb);
        sched_yield();
        
    }
}


void TEMP_test_scheduler()
{
    struct thread *th1 = new_thread(thread1);
    scheduler_insert(th1);

    struct thread *th2 = new_thread(thread2);
    scheduler_insert(th2);
}